﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WinFormWithParameters
{
    public partial class Form1 : Form
    {
        private bool InteractiveMode = true;
        private int FinalExitCode = 0;

        public Form1(string[] args)
        {
            InitializeComponent();
            for (int iExitCode = 1; iExitCode < 256; iExitCode++)
            {
                cbxExitCode.Items.Add(iExitCode);
            }
            if (args.Length > 0 && (args.Length > 1 || args[0].Length > 0))
            {
                foreach (string s in args)
                {
                    textBox1.Text += string.Format("arg: {0}\r\n", s);
                }
                this.timer1.Interval = 5000;
                this.timer1.Enabled = true;
                InteractiveMode = false;
                cbxExitCode.SelectedIndex = 199;  // 200
                this.btnTerminate.Enabled = false;
                this.textBox1.Enabled = false;
                this.cbxExitCode.Enabled = false;
            }
            else
            {
                this.textBox1.Text = "(no arguments provided)";
                InteractiveMode = true;
                this.timer1.Enabled = false;
            }
        }

        private int DoWork()
        {
            int iExitCode = 47;

            return iExitCode;
        }

        private void btnTerminate_Click(object sender, EventArgs e)
        {
            FinalExitCode = DoWork();
            this.Close();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.Environment.ExitCode = this.cbxExitCode.SelectedIndex >= 0 ? (int)this.cbxExitCode.Items[this.cbxExitCode.SelectedIndex] : FinalExitCode;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
